<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMoveAudienceTargetInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfMoveAudienceTargetInfo
 * @subpackage Arrays
 */
class ArrayOfMoveAudienceTargetInfo extends AbstractStructArrayBase
{
    /**
     * The MoveAudienceTargetInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\MoveAudienceTargetInfo[]
     */
    public $MoveAudienceTargetInfo;
    /**
     * Constructor method for ArrayOfMoveAudienceTargetInfo
     * @uses ArrayOfMoveAudienceTargetInfo::setMoveAudienceTargetInfo()
     * @param \patest\StructType\MoveAudienceTargetInfo[] $moveAudienceTargetInfo
     */
    public function __construct(array $moveAudienceTargetInfo = array())
    {
        $this
            ->setMoveAudienceTargetInfo($moveAudienceTargetInfo);
    }
    /**
     * Get MoveAudienceTargetInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\MoveAudienceTargetInfo[]|null
     */
    public function getMoveAudienceTargetInfo()
    {
        return isset($this->MoveAudienceTargetInfo) ? $this->MoveAudienceTargetInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMoveAudienceTargetInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMoveAudienceTargetInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMoveAudienceTargetInfoForArrayConstraintsFromSetMoveAudienceTargetInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMoveAudienceTargetInfoMoveAudienceTargetInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfMoveAudienceTargetInfoMoveAudienceTargetInfoItem instanceof \patest\StructType\MoveAudienceTargetInfo) {
                $invalidValues[] = is_object($arrayOfMoveAudienceTargetInfoMoveAudienceTargetInfoItem) ? get_class($arrayOfMoveAudienceTargetInfoMoveAudienceTargetInfoItem) : sprintf('%s(%s)', gettype($arrayOfMoveAudienceTargetInfoMoveAudienceTargetInfoItem), var_export($arrayOfMoveAudienceTargetInfoMoveAudienceTargetInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MoveAudienceTargetInfo property can only contain items of type \patest\StructType\MoveAudienceTargetInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MoveAudienceTargetInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\MoveAudienceTargetInfo[] $moveAudienceTargetInfo
     * @return \patest\ArrayType\ArrayOfMoveAudienceTargetInfo
     */
    public function setMoveAudienceTargetInfo(array $moveAudienceTargetInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($moveAudienceTargetInfoArrayErrorMessage = self::validateMoveAudienceTargetInfoForArrayConstraintsFromSetMoveAudienceTargetInfo($moveAudienceTargetInfo))) {
            throw new \InvalidArgumentException($moveAudienceTargetInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($moveAudienceTargetInfo) || (is_array($moveAudienceTargetInfo) && empty($moveAudienceTargetInfo))) {
            unset($this->MoveAudienceTargetInfo);
        } else {
            $this->MoveAudienceTargetInfo = $moveAudienceTargetInfo;
        }
        return $this;
    }
    /**
     * Add item to MoveAudienceTargetInfo value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\MoveAudienceTargetInfo $item
     * @return \patest\ArrayType\ArrayOfMoveAudienceTargetInfo
     */
    public function addToMoveAudienceTargetInfo(\patest\StructType\MoveAudienceTargetInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\MoveAudienceTargetInfo) {
            throw new \InvalidArgumentException(sprintf('The MoveAudienceTargetInfo property can only contain items of type \patest\StructType\MoveAudienceTargetInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MoveAudienceTargetInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\MoveAudienceTargetInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\MoveAudienceTargetInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\MoveAudienceTargetInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\MoveAudienceTargetInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\MoveAudienceTargetInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MoveAudienceTargetInfo
     */
    public function getAttributeName()
    {
        return 'MoveAudienceTargetInfo';
    }
}
